// Thumbs		10000 `
// Child		1524 `
// Tool			1572

#define MYWNDCLASS		"CLASS_Mapy2"
#define MYWNDTITLE		"Mapy2"

HINSTANCE	g_hInst		= NULL;	// CX^Xnh
HMENU		g_hMenu		= NULL;

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Set_Class(char *cls, WNDPROC ProcWnd);
HWND Set_Child(HWND hWnd, char *cls, int wdh, int hgt, DWORD exStyle);
HWND Set_Tool(HWND hWnd);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	// dNh~&R}hCn
	HWND hWnd = FindWindow(MYWNDCLASS, NULL);
	if(hWnd){
		SetForegroundWindow(hWnd);
		if(__argc > 1){
			COPYDATASTRUCT cds;
			ZeroMemory(&cds, sizeof(cds));
			cds.cbData = strlen(__argv[1])+1;
			cds.lpData = __argv[1];
			SendMessage(hWnd, WM_COPYDATA, NULL, (LPARAM)&cds);
		}
		return 0;
	}
	
	MSG 	   msg;
	WNDCLASSEX wc;
	
	g_hInst = hInst;
	
	// eEBhENX̓o^
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	g_hMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU1));
	
	int frame = GetSystemMetrics(SM_CXFRAME);
	
	// eEBhE̍쐬
	hWnd = CreateWindowEx(0,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_CLIPCHILDREN,
				CW_USEDEFAULT, CW_USEDEFAULT, frame * 2 + 23 * 15, 400,
				NULL,
				g_hMenu,
				hInst,
				NULL);
	
	HACCEL hAC = LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_ACCELERATOR1));
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		if(TranslateAccelerator(hWnd, hAC, &msg))
			continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

// EBhENX̓o^
void Set_Class(char *cls, WNDPROC ProcWnd)
{
	WNDCLASSEX wc;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= GetModuleHandle(NULL);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.style			= CS_DBLCLKS;
	wc.lpszClassName	= cls;
	RegisterClassEx(&wc);
	
}// Set_Class_Child

// qEBhE̍쐬
HWND Set_Child(HWND hWnd, char *cls, int wdh, int hgt, DWORD exStyle)
{
	static int k = 0;
	
	HWND hChild = CreateWindowEx(
				exStyle,
				cls,
				NULL,
				WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
				0, 0, wdh, hgt,
				hWnd,
				(HMENU) 1524 + k++,
				GetModuleHandle(NULL),
				NULL);
	return (hChild);
}// Set_Child

// c[o[̍쐬
HWND Set_Tool(HWND hParent)
{
    HWND hTool = CreateWindowEx( 0,
                                 TOOLBARCLASSNAME,
                                 NULL,
                                 WS_CHILD | WS_VISIBLE | CCS_TOP | TBSTYLE_FLAT | TBSTYLE_WRAPABLE,
                                 0, 0, 0, 0,
                                 hParent,
                                 (HMENU) 1572,
                                 g_hInst,
                                 NULL);
    SendMessage(hTool,TB_BUTTONSTRUCTSIZE,sizeof(TBBUTTON),0);
    return (hTool);
}
