#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "setwin.h"
#include "setscrollbar_img.h"
#include "bucket.h"

#define CHILD_CLASS		"CLASS_CHILD_MAPY2"
#define PIC_WDH			16		// 摜̉
#define PIC_HGT			16		// 摜̍
#define PIC_NUM			45		// 摜̐
#define MAP_WDH			400 	// n}̉̍ő吔íAPIC_WDH px ~ MAP_WDHj
#define MAP_HGT			400 	// n}̍̍ő吔íAPIC_HGT px ~ MAP_HGTj
#define UNDO_MAX		1024	// [ɖ߂]̗̍ő吔
#define COLOR_BITW		24		// ƗpDIB̐F[xigl 24 ̂݁j
#define DELGDIOBJ(p) 	if (p){DeleteObject(p);p=NULL;}

typedef struct{
	int x;			// ̈ʒu
	int y;			// c̈ʒu
	int n;			// 摜ԍ
}UNDO,*LPUNDO;

UNDO		g_Undo[UNDO_MAX];	// [ɖ߂]Ŏgp闚i[
int			g_Undo_ct = -1;		// [ɖ߂]݂̌̃JEg
bool		g_flag_Undo_off;	// [ɖ߂]j[̏ԃtO[0:L 1:]
bool		g_flag_Redo_off;	// [蒼]j[̏ԃtO[0:L 1:]
bool		g_flag_Undo_Max;	// [ɖ߂]̃JEgUNDO_MAXɒB?
HWND		g_hWnd,g_hChild,g_hTool;
HCURSOR		g_hcurArrow = NULL;
HCURSOR		g_hcurPen = NULL;
HCURSOR		g_hcurBucket = NULL;
HIMAGELIST	g_hIml = NULL;
HBITMAP		g_hBmp[PIC_NUM];
HBITMAP 	g_hBmpWork = NULL;				// Ɨprbg}bv
BYTE		*g_pBitsWork = NULL;			// ƗpsNZ f[^
char		g_file_name[MAX_PATH];			// ǂݍ݁Eۑt@C
int 		g_map_w = 16,g_map_h = 16;		// }bv̕ƍ
BYTE 		g_map[MAP_HGT][MAP_WDH];		// }bvf[^i[
BYTE 		g_sel[MAP_HGT][MAP_WDH];		// }bvZ̑IԂi[i0:IA1:IA2:Ij
int 		g_copy_map[MAP_HGT][MAP_WDH];	// }bvf[^̃Rs[i[
BYTE 		g_copy_sel[MAP_HGT][MAP_WDH];	// IԂ̃Rs[i[
int			g_flag_mode = 1;				// [h tOi0:IA1:`A2:hׂj
POINT		g_ptContextMenu = {-1,-1};
bool		g_bShowGrid = true;				// Obh\tO

LRESULT	CALLBACK ProcChildWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL	CALLBACK ProcDlg(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void	M_ContextMenu(HWND hWnd);
void	M_Paint(HWND hWnd, HDC hDC, int nWidth, int nHeight);
HBITMAP	Create_WorkDib(PVOID *ppBits, int nWidth, int nHeight, int bpp);
RECT	Get_MouseRect(POINT ptStart, POINT ptEnd);
void	Change_Cursor();
void	Add_Buttons(HWND hParent);
void	Insert_Bttn(int num);
void	Clear_Select();
void	Clear_Map();
int		Get_ChipIndex();
POINT	Get_CellPos(LPARAM lParam);
POINT	Get_CellPos(POINT pos);
POINT	Get_CellPosContextMenu();
bool	Set_Value(int x, int y);
bool	Set_Value(int x, int y, int val, bool bReDraw);
void	ReDraw(int x, int y);
bool	Is_SelExist();
bool	Is_CopyDataExist();
void	Select_AllCell();
void	Bucket2(int x, int y, BYTE val);
void	Set_UnDo1(int x, int y, int n);
void	Set_UnDo2(int x, int y, int n);
void	UnDo();
void	ReDo();
void	Load_Dialog(HWND hWnd);
bool	Load();
void	Save_Dialog(HWND hWnd);
bool	Save();
void	Set_Title();
void	Set_SubMenuState(HMENU hMenuSub, int index);
void	Set_PopUpMenuState(HMENU hMenu);
void	Menu_State_Change(HMENU hMenu, UINT ID, UINT state);

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		{
			int i;
			g_hWnd = hWnd;
			if(__argc > 1){
				strcpy(g_file_name, __argv[1]);
				if(!Load()){
					MessageBox(hWnd, "t@Cǂݍ߂܂", MYWNDTITLE, MB_OK);
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					return 0;
				}
			}
			// qEBhENX̓o^
			Set_Class(CHILD_CLASS, ProcChildWnd);
			// qEBhEt
			g_hChild = Set_Child(hWnd, CHILD_CLASS, 0, 0,
								WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES);
			// RRg[̏
			InitCommonControls();
			// c[o[t
			g_hTool = Set_Tool(hWnd);
			// c[o[Ƀ{^ǉ
			Add_Buttons(hWnd);
			// {^I
			SendMessage(g_hTool, TB_CHECKBUTTON, 10000, MAKELONG(TRUE, 0));
			// [ɖ߂]̏
			for(i=0;i<UNDO_MAX;i++){
				g_Undo[i].x = -1;
			}
			g_flag_Undo_off = TRUE;
			g_flag_Redo_off = TRUE;
			g_flag_Undo_Max = FALSE;
		}
		break;
		
	case WM_SIZE:
		{
			RECT	rc_t;
			int		wdh,hgt;
			wdh = LOWORD(lParam);
			hgt = HIWORD(lParam);
			SendMessage(g_hTool, WM_SIZE, 0, 0);
			GetWindowRect(g_hTool, &rc_t);
			MoveWindow(g_hChild, 0, rc_t.bottom-rc_t.top, wdh, hgt-(rc_t.bottom-rc_t.top), TRUE);
		}
		break;
		
	case WM_COPYDATA:		// ɃvOsĂƂ
		{
			COPYDATASTRUCT *pcds;
			pcds = (COPYDATASTRUCT*) lParam;
			if(pcds->cbData > 0){
				strcpy(g_file_name, (char*)pcds->lpData);
				if(!Load()){
					MessageBox(hWnd, "t@Cǂݍ߂܂", MYWNDTITLE, MB_OK);
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					return 0;
				}
			}
		}
		break;
		
	case WM_MENUSELECT: 	// j[ACeNbNꂽƂ
		{
			UINT index = (UINT) LOWORD(wParam);
			UINT flags = (UINT) HIWORD(wParam);
			if(index != -1 && (flags & (MF_SYSMENU | MF_POPUP))){
				HMENU hMenu  = (HMENU) lParam;
				HMENU hMenuSub = GetSubMenu(hMenu, index);
				Set_SubMenuState(hMenuSub, index);
			}
		}
		break;
		
	case WM_CONTEXTMENU:
		M_ContextMenu(hWnd);
		break;
		
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDM_NEW:		// VK쐬
			{
				int r;
				r = MessageBox(hWnd, "ҏW̃f[^ۑ܂H", MYWNDTITLE, MB_YESNOCANCEL);
				if(r == IDCANCEL){
					break;
				}
				else if(r == IDYES){
					Save_Dialog(hWnd);
				}
				DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG1), hWnd, (DLGPROC)ProcDlg);
				Clear_Select();
				Clear_Map();
			}
			break;
			
		case IDM_OPEN:		// J
			Load_Dialog(hWnd);
			break;
			
		case IDM_SAVE:		// ㏑ۑ
			if(strcmp(g_file_name, "")){
				Save();
			}
			else{
				Save_Dialog(hWnd);
			}
			break;
			
		case IDM_SAVEAS:	// Otĕۑ
			Save_Dialog(hWnd);
			break;
			
		case IDM_EXIT:		// I
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
			
		case IDM_UNDO:		// ɖ߂
            UnDo();
            break;
			
        case IDM_REDO:		// 蒼
            ReDo();
            break;
			
        case IDM_MODE_SELECT:	// I[h
			g_flag_mode = 0;
			InvalidateRect(g_hChild, NULL, FALSE);
            break;
			
        case IDM_MODE_LINE:		// `[h
			g_flag_mode = 1;
			InvalidateRect(g_hChild, NULL, FALSE);
            break;
			
		case IDM_MODE_BUCKET:	// hׂ[h
			g_flag_mode = 2;
			InvalidateRect(g_hChild, NULL, FALSE);
			break;
			
		case IDM_CUT:		// ؂
			if(g_flag_mode == 0){
				int i,j;
				if(!Is_SelExist()){
					if(g_ptContextMenu.x == -1){
						MessageBox(hWnd, "؂ZIĂ", MYWNDTITLE, MB_OK);
						break;
					}
					else{
						POINT pos = Get_CellPosContextMenu();
						g_sel[pos.y][pos.x] = 1;
						g_ptContextMenu.x = -1;
					}
				}
				memcpy(g_copy_map, g_map, sizeof(g_copy_map));
				memcpy(g_copy_sel, g_sel, sizeof(g_copy_sel));
				for(j=0;j<g_map_h;j++){
					for(i=0;i<g_map_w;i++){
						if(g_sel[j][i] == 1){
							Set_Value(i, j, 0, false);
						}
					}
				}
				ZeroMemory(g_sel, sizeof(g_sel));
				InvalidateRect(g_hChild, NULL, FALSE);
			}
			break;
			
		case IDM_COPY:		// Rs[
			if(g_flag_mode == 0){
				if(!Is_SelExist()){
					if(g_ptContextMenu.x == -1){
						MessageBox(hWnd, "Rs[ZIĂ", MYWNDTITLE, MB_OK);
						break;
					}
					else{
						POINT pos = Get_CellPosContextMenu();
						g_sel[pos.y][pos.x] = 1;
						g_ptContextMenu.x = -1;
					}
				}
				memcpy(g_copy_map, g_map, sizeof(g_copy_map));
				memcpy(g_copy_sel, g_sel, sizeof(g_copy_sel));
				ZeroMemory(g_sel, sizeof(g_sel));
				InvalidateRect(g_hChild, NULL, FALSE);
			}
			break;
			
		case IDM_PASTE:		// \t
			if(g_flag_mode == 0){
				if(!Is_SelExist()){
					if(g_ptContextMenu.x == -1){
						MessageBox(hWnd, "\t̃ZIĂ", MYWNDTITLE, MB_OK);
						break;
					}
					else{
						POINT pos = Get_CellPosContextMenu();
						g_sel[pos.y][pos.x] = 1;
						g_ptContextMenu.x = -1;
					}
				}
				int		i,j;
				POINT	ptMin = {MAP_WDH,MAP_HGT},ptMax = {0,0};
				for(j=0;j<g_map_h;j++){
					for(i=0;i<g_map_w;i++){
						if(g_copy_sel[j][i] == 1){
							if(ptMin.x > i)
								ptMin.x = i;
							if(ptMax.x < i)
								ptMax.x = i;
							if(ptMin.y > j)
								ptMin.y = j;
							if(ptMax.y < j)
								ptMax.y = j;
						}
					}
				}
				POINT	ptDst = {MAP_WDH,MAP_HGT};
				for(j=0;j<g_map_h;j++){
					for(i=0;i<g_map_w;i++){
						if(g_sel[j][i] == 1){
							if(ptDst.x > i)
								ptDst.x = i;
							if(ptDst.y > j)
								ptDst.y = j;
						}
					}
				}
				for(j=ptMin.y;j<=ptMax.y;j++){
					for(i=ptMin.x;i<=ptMax.x;i++){
						if(g_copy_sel[j][i] == 1){
							Set_Value(i - ptMin.x + ptDst.x, j - ptMin.y + ptDst.y, g_copy_map[j][i], false);
						}
					}
				}
				ZeroMemory(g_sel, sizeof(g_sel));
				InvalidateRect(g_hChild, NULL, FALSE);
			}
			break;
			
		case IDM_SELALL:	// đI
			Select_AllCell();
			InvalidateRect(g_hChild, NULL, FALSE);
			break;
			
		case IDM_RELEASECELL:	// ̃ZI
			if(g_flag_mode == 0){
				POINT pos = Get_CellPosContextMenu();
				g_sel[pos.y][pos.x] = 0;
				ReDraw(pos.x, pos.y);
			}
			break;
			
		case IDM_DELETECELL:	// ̃Z
			if(g_flag_mode > 0){
				POINT pos = Get_CellPosContextMenu();
				g_map[pos.y][pos.x] = 0;
				ReDraw(pos.x, pos.y);
			}
			break;
			
		case IDM_BUCKET:	// hׂ
			if(g_flag_mode > 0){
				POINT pos = Get_CellPosContextMenu();
				Bucket2(pos.x, pos.y, Get_ChipIndex());
				InvalidateRect(g_hChild, NULL, FALSE);
			}
			break;
			
		case IDM_CLEAR:		// NA
			switch (g_flag_mode)
			{
			case 0:
				Clear_Select();
				break;
			case 1:
			case 2:
				Clear_Map();
				break;
			}
			break;
			
		case IDM_RESIZE:	// }bvTCYύX
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG1), hWnd, (DLGPROC)ProcDlg);
			break;
			
		case IDM_GRID:		// Obh\
			if(!g_bShowGrid)
				g_bShowGrid = true;
			else
				g_bShowGrid = false;
			InvalidateRect(g_hChild, NULL, FALSE);
			break;
			
        case IDM_MODE:		// [h
			switch (g_flag_mode)
			{
			case 0:
				g_flag_mode = 1;
				break;
			case 1:
				g_flag_mode = 2;
				break;
			case 2:
				g_flag_mode = 0;
				break;
			}
			// |C^ύX
			Change_Cursor();
			InvalidateRect(g_hChild, NULL, FALSE);
            break;
		}
		break;
		
	case WM_CLOSE:
		{
			int i;
			// rbg}bv
			DELGDIOBJ(g_hBmpWork);
			for(i=0;i<PIC_NUM;i++){
				DELGDIOBJ(g_hBmp[i]);
			}
			// C[WXg
			if(g_hIml)
				ImageList_Destroy(g_hIml);
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		}
		break;
		
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// ProcWnd

// qEBhEvV[W
LRESULT CALLBACK ProcChildWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int		wdh = 0; // NCAg̈̕
	static int		hgt = 0; // NCAg̈̍
	static POINT	ptSelStart = {0, 0};	// IJnZʒu
	static bool		bSelErase = false;		// ItO
	
	switch (uMsg)
	{
	case WM_CREATE:
		// XN[o[
		Set_ScrollBar(hWnd);
		Set_Scroll_nMax(hWnd, g_map_w*PIC_WDH+6, g_map_h*PIC_HGT+6);
		// J[\ǂݍ
		g_hcurArrow = LoadCursor(NULL, IDC_ARROW);
		g_hcurPen = LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_CURSOR1));
		g_hcurBucket = LoadCursor(g_hInst, MAKEINTRESOURCE(IDC_CURSOR2));
		break;
		
	case WM_SIZE:			// EBhETCYύXꂽ
		wdh = LOWORD(lParam);
		hgt = HIWORD(lParam);
		Set_Scroll_nPage(g_hChild);
		InvalidateRect(hWnd, NULL, FALSE);
		break;
		
	case WM_HSCROLL:		// XN[o[
		Move_Scroll_H(hWnd, wParam);
		break;
		
	case WM_VSCROLL:		// cXN[o[
		Move_Scroll_V(hWnd, wParam);
		break;
		
	case WM_DROPFILES:		// EBhEւ Drag&Drag
		{
			HDROP	hDrop;
			hDrop = (HDROP) wParam;
			DragQueryFile(hDrop, 0, g_file_name, sizeof(g_file_name));
			if(!Load()){
				MessageBox(g_hWnd, "t@Cǂݍ߂܂", MYWNDTITLE, MB_OK);
				SendMessage(g_hWnd, WM_CLOSE, 0, 0);
				return 0;
			}
			DragFinish(hDrop);
			SetForegroundWindow(hWnd);
		}
		break;
		
	case WM_PAINT:
		{
			HDC hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd, &ps);
			M_Paint(hWnd, hDC, wdh, hgt);
			EndPaint(hWnd, &ps);
		}
		break;
		
	case WM_LBUTTONDOWN:	// }EX̍{^ꂽ
		{
			SetCapture(hWnd);
			POINT pos = Get_CellPos(lParam);
			switch (g_flag_mode)
			{
			case 0:
				ptSelStart = pos;
				if(g_sel[pos.y][pos.x] == 1){
					bSelErase = true;
				}
				else{
					bSelErase = false;
				}
				g_sel[pos.y][pos.x] |= 2;
				ReDraw(pos.x, pos.y);
				break;
			case 1:
				Set_Value(pos.x, pos.y);
				break;
			case 2:
				Bucket2(pos.x, pos.y, Get_ChipIndex());
				InvalidateRect(g_hChild, NULL, FALSE);
				break;
			}
			// |C^ύX
			Change_Cursor();
		}
		break;
		
	case WM_LBUTTONUP:		// }EX̍{^オ
		{
			ReleaseCapture();
			switch (g_flag_mode)
			{
			case 0:
				{
					int i,j;
					for(j=0;j<g_map_h;j++){
						for(i=0;i<g_map_w;i++){
							if(g_sel[j][i] & 2){
								if(bSelErase){
									g_sel[j][i] = 0;
								}
								else{
									g_sel[j][i] = 1;
								}
								ReDraw(i, j);
							}
						}
					}
					ptSelStart.x = 0;
					ptSelStart.y = 0;
				}
				break;
			}
			// |C^ύX
			Change_Cursor();
		}
		break;
		
	case WM_MOUSEMOVE:		// }EX
		if(GetCapture() == hWnd){
			POINT	pos = Get_CellPos(lParam);
			switch (g_flag_mode)
			{
			case 0:
				if(wParam & MK_LBUTTON){
					int i,j;
					for(j=0;j<g_map_h;j++){
						for(i=0;i<g_map_w;i++){
							if(g_sel[j][i] & 2){
								g_sel[j][i] &= ~2;
							}
						}
					}
					RECT rc = Get_MouseRect(ptSelStart, pos);
					for(j=rc.top;j<=rc.bottom;j++){
						for(i=rc.left;i<=rc.right;i++){
							g_sel[j][i] |= 2;
						}
					}
					InvalidateRect(hWnd, NULL, FALSE);
				}
				break;
			case 1:
				// {^ꂽ
				if(wParam & MK_LBUTTON){
					static POINT	pos_pre = {-1, -1};
					if(pos.x != pos_pre.x || pos.y != pos_pre.y){
						Set_Value(pos.x, pos.y);
						pos_pre = pos;
					}
				}
				break;
			}
		}
		// |C^ύX
		Change_Cursor();
		break;
		
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// ProcChildWnd

// ݒ_CAOvV[W
BOOL CALLBACK ProcDlg( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static HWND	hCombo1,hCombo2;
	
	switch( uMsg )
	{			
	case WM_INITDIALOG:
		{
			int 	i,cn;
			char	str2[4];
			// Rg[̃nh擾
			hCombo1 = GetDlgItem(hDlg, IDC_COMBO1);
			hCombo2 = GetDlgItem(hDlg, IDC_COMBO2);
			
			for(i=8;i<=MAP_WDH;i++){
				SendMessage (hCombo1, CB_ADDSTRING, 0, (LPARAM)_itoa(i, str2, 10));
				if(g_map_w == i){
					cn = i - 8;
				}
			}
			SendMessage (hCombo1, CB_SETCURSEL, cn, 0);
			
			for(i=8;i<=MAP_HGT;i++){
				SendMessage (hCombo2, CB_ADDSTRING, 0, (LPARAM)_itoa(i, str2, 10));
				if(g_map_h == i){
					cn = i - 8;
				}
			}
			SendMessage (hCombo2, CB_SETCURSEL, cn, 0);
		}
		break;
			
	case WM_COMMAND:
		switch( wParam )
		{
		case IDC_COMBO1 | (CBN_SELCHANGE<<16):
			{
				int cn;
				cn = SendMessage (hCombo1, CB_GETCURSEL, 0, 0);
				if(cn >= 0){
					g_map_w = cn + 8;
				}
				if(g_map_w <= 0){
					g_map_w = 8;
				}
				if(g_hChild){
					Set_Scroll_nMax(g_hChild, g_map_w*PIC_WDH+6, g_map_h*PIC_HGT+6);
					InvalidateRect(g_hChild, NULL, FALSE);
				}
			}
			return TRUE;
			
		case IDC_COMBO2 | (CBN_SELCHANGE<<16):
			{
				int cn;
				cn = SendMessage (hCombo2, CB_GETCURSEL, 0, 0);
				if(cn >= 0){
					g_map_h = cn + 8;
				}
				if(g_map_h <= 0)	g_map_h = 8;
				if(g_hChild){
					Set_Scroll_nMax(g_hChild, g_map_w*PIC_WDH+6, g_map_h*PIC_HGT+6);
					InvalidateRect(g_hChild, NULL, FALSE);
				}
			}
			return TRUE;
			
		case IDOK:
			EndDialog(hDlg, TRUE);
			return TRUE;
			
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			return TRUE;
		}
		return FALSE;
		
	default:
		return FALSE;
	}
	return TRUE;
}// ProcDlg

// ReLXgj[ bZ[W
void M_ContextMenu(HWND hWnd)
{
	HMENU	hMenu,hMenu_Pop;
	
	GetCursorPos(&g_ptContextMenu);
	hMenu = LoadMenu(g_hInst, MAKEINTRESOURCE(IDR_MENU2));
	switch (g_flag_mode)
	{
	case 0:
		hMenu_Pop = GetSubMenu(hMenu, 0);
		break;
	case 1:
		hMenu_Pop = GetSubMenu(hMenu, 1);
		break;
	case 2:
		hMenu_Pop = GetSubMenu(hMenu, 2);
		break;
	}
	Set_PopUpMenuState(hMenu_Pop);
	TrackPopupMenu(hMenu_Pop, TPM_LEFTALIGN | TPM_RIGHTBUTTON,
					g_ptContextMenu.x, g_ptContextMenu.y, 0, hWnd, NULL);
	DestroyMenu(hMenu);
}// M_ContextMenu

// `iWM_PAINTj ̏
// nWidth	: [IN] EBhE̕
// nHeight	: [IN] EBhE̍
void M_Paint(HWND hWnd, HDC hDC, int nWidth, int nHeight)
{
	HDC 	hDCcp1 = NULL;
	HBITMAP hBmpPre1 = NULL;
	DELGDIOBJ(g_hBmpWork);
	g_hBmpWork = Create_WorkDib((PVOID *) &g_pBitsWork, nWidth, nHeight, COLOR_BITW);
	if(g_hBmpWork){
		hDCcp1 = CreateCompatibleDC(hDC);
		hBmpPre1 = (HBITMAP) SelectObject(hDCcp1, g_hBmpWork);
		RECT rc = {0, 0, nWidth, nHeight};
		HRGN hrgn = CreateRectRgnIndirect(&rc);
		SelectClipRgn(hDCcp1, hrgn);
		DELGDIOBJ(hrgn);
		// Obh`
		int		i,j;
		HPEN	hPen = NULL,hPenPre = NULL;
		HBRUSH	hBrush = NULL,hBrushPre = NULL;
		hBrush = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
		hBrushPre = (HBRUSH)SelectObject(hDCcp1, hBrush);
		hPen = (HPEN)CreatePen(PS_SOLID, 1, RGB(100,100,0));
		hPenPre = (HPEN)SelectObject(hDCcp1, hPen);
		for(j=0;j<g_map_h;j++){
			for(i=0;i<g_map_w;i++){
				Rectangle(hDCcp1, i*PIC_WDH+3-scr_x, j*PIC_HGT+3-scr_y, i*PIC_WDH+3+PIC_WDH+1-scr_x, j*PIC_HGT+3+PIC_HGT+1-scr_y);
			}
		}
		// rbg}bv`
		HDC 	hDCCpt = NULL;
		for(j=0;j<g_map_h;j++){
			for(i=0;i<g_map_w;i++){
				if(g_map[j][i] > 0){
					hDCCpt = CreateCompatibleDC(hDCcp1);
					SelectObject(hDCCpt, g_hBmp[g_map[j][i]-1]);
					BitBlt(hDCcp1, i*PIC_WDH+3-scr_x, j*PIC_HGT+3-scr_y, PIC_WDH, PIC_HGT, hDCCpt, 0, 0, SRCCOPY);
					DeleteDC(hDCCpt);
				}
			}
		}
		HBRUSH	hBrushNull = (HBRUSH)GetStockObject(NULL_BRUSH);
		SelectObject(hDCcp1, hBrushNull);
		// Obh`
		if(g_bShowGrid){
			for(j=0;j<g_map_h;j++){
				for(i=0;i<g_map_w;i++){
					if(g_map[j][i] > 0){
						Rectangle(hDCcp1, i*PIC_WDH+3-scr_x, j*PIC_HGT+3-scr_y, i*PIC_WDH+3+PIC_WDH+1-scr_x, j*PIC_HGT+3+PIC_HGT+1-scr_y);
					}
				}
			}
		}
		if(g_flag_mode == 0){
			// Ig`
			HPEN	hPenSel = (HPEN)CreatePen(PS_SOLID, 1, RGB(0,0,255));
			SelectObject(hDCcp1, hPenSel);
			for(j=0;j<g_map_h;j++){
				for(i=0;i<g_map_w;i++){
					if(g_sel[j][i] == 1){
						Rectangle(hDCcp1, i*PIC_WDH+3-scr_x, j*PIC_HGT+3-scr_y, i*PIC_WDH+3+PIC_WDH+1-scr_x, j*PIC_HGT+3+PIC_HGT+1-scr_y);
					}
				}
			}
			DELGDIOBJ(hPenSel);
			// Ig`
			HPEN	hPenSelProposed = (HPEN)CreatePen(PS_SOLID, 1, RGB(0,255,255));
			SelectObject(hDCcp1, hPenSelProposed);
			for(j=0;j<g_map_h;j++){
				for(i=0;i<g_map_w;i++){
					if(g_sel[j][i] & 2){
						Rectangle(hDCcp1, i*PIC_WDH+3-scr_x, j*PIC_HGT+3-scr_y, i*PIC_WDH+3+PIC_WDH+1-scr_x, j*PIC_HGT+3+PIC_HGT+1-scr_y);
					}
				}
			}
			DELGDIOBJ(hPenSelProposed);
		}
		SelectObject(hDCcp1, hPenPre);
		SelectObject(hDCcp1, hBrushPre);
		BitBlt(hDC, 0, 0, nWidth, nHeight, hDCcp1, 0, 0, SRCCOPY);
		DELGDIOBJ(hPen);
		SelectObject(hDCcp1, hBmpPre1);
		SelectClipRgn(hDCcp1, (HRGN) NULL);
		DeleteDC(hDCcp1);
		DELGDIOBJ(g_hBmpWork);
	}
}// M_Paint

// Ɨp DIB ̍쐬
// pBits	: [OUT] 󂯎sNZl
// nWidth	: [IN]  
// nHeight	: [IN]  
// bpp		: [IN]  F[x
// ߂l	: 쐬ꂽrbg}bvnh
HBITMAP Create_WorkDib(PVOID *ppBits, int nWidth, int nHeight, int bpp)
{
	HBITMAP hBmp = NULL;
	
	BITMAPINFO	bmi;
	
	ZeroMemory(&bmi, sizeof(bmi));
	bmi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bmi.bmiHeader.biWidth			= nWidth;
	bmi.bmiHeader.biHeight			= nHeight;
	bmi.bmiHeader.biPlanes			= 1;
	bmi.bmiHeader.biBitCount		= bpp;
	bmi.bmiHeader.biCompression 	= BI_RGB;
	
	hBmp = (HBITMAP) CreateDIBSection(NULL, &bmi, DIB_RGB_COLORS, ppBits, NULL, 0);
	return hBmp;
}// Create_WorkDib

// hbO`擾
RECT Get_MouseRect(POINT ptStart, POINT ptEnd)
{
	RECT rc = {0,0,0,0};
	// Jnʒu`̍AIʒuEɂȂ悤ɂ
	if(ptStart.x <= ptEnd.x){
		rc.left		= ptStart.x;
		rc.right	= ptEnd.x;
	}
	else{
		rc.left		= ptEnd.x;
		rc.right	= ptStart.x;
	}
	if(ptStart.y <= ptEnd.y){
		rc.top		= ptStart.y;
		rc.bottom	= ptEnd.y;
	}
	else{
		rc.top		= ptEnd.y;
		rc.bottom	= ptStart.y;
	}
	return rc;
}// Get_MouseRect

// |C^ύX
void Change_Cursor()
{
	if(!(GetKeyState(VK_CONTROL) & 0x8000) && 
		!(GetKeyState('C') & 0x8000) && !(GetKeyState('X') & 0x8000) && !(GetKeyState('V') & 0x8000))
	{
		switch(g_flag_mode)
		{
		case 0:
			SetCursor(g_hcurArrow);
			break;
		case 1:
			SetCursor(g_hcurPen);
			break;
		case 2:
			SetCursor(g_hcurBucket);
			break;
		}
	}
}// Change_Cursor

// wW`bv̔
// c[o[Ƀ{^ǉ
void Add_Buttons(HWND hParent)
{
	// C[WXg̍쐬
	g_hIml	= ImageList_Create(PIC_WDH, PIC_HGT, ILC_COLORDDB, 0, 0);
	SendMessage(g_hTool, TB_SETIMAGELIST, 0, (LPARAM) g_hIml);
	
	g_hBmp[0]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T01));
	g_hBmp[1]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T02));
	g_hBmp[2]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T03));
	g_hBmp[3]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T04));
	g_hBmp[4]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T05));
	g_hBmp[5]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T06));
	g_hBmp[6]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T07));
	g_hBmp[7]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T08));
	g_hBmp[8]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T09));
	g_hBmp[9]  = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T10));
	g_hBmp[10] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T11));
	g_hBmp[11] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T12));
	g_hBmp[12] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T13));
	g_hBmp[13] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T14));
	g_hBmp[14] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T15));
	g_hBmp[15] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T16));
	g_hBmp[16] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T17));
	g_hBmp[17] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T18));
	g_hBmp[18] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T19));
	g_hBmp[19] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T20));
	g_hBmp[20] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T21));
	g_hBmp[21] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T22));
	g_hBmp[22] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T23));
	g_hBmp[23] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T24));
	g_hBmp[24] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T25));
	g_hBmp[25] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T26));
	g_hBmp[26] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T27));
	g_hBmp[27] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T28));
	g_hBmp[28] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T29));
	g_hBmp[29] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T30));
	g_hBmp[30] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T31));
	g_hBmp[31] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T32));
	g_hBmp[32] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T33));
	g_hBmp[33] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T34));
	g_hBmp[34] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T35));
	g_hBmp[35] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T36));
	g_hBmp[36] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T37));
	g_hBmp[37] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T38));
	g_hBmp[38] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T39));
	g_hBmp[39] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T40));
	g_hBmp[40] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T41));
	g_hBmp[41] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T42));
	g_hBmp[42] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T43));
	g_hBmp[43] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_T44));
	g_hBmp[44] = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_E));
	
	// c[o[Ƀ{^Ɖ摜ǉ
	for(int i=0;i<PIC_NUM;i++){
		ImageList_Add(g_hIml, (HBITMAP) g_hBmp[i], NULL);
		Insert_Bttn(i);
	}
}// Add_Buttons

// c[o[Ƀ{^Pǉ
void Insert_Bttn(int num)
{
	TBBUTTON tbb;
	ZeroMemory(&tbb, sizeof(TBBUTTON));
	tbb.fsStyle   = TBSTYLE_AUTOSIZE | TBSTYLE_CHECKGROUP;
	tbb.fsState   = TBSTATE_ENABLED;
	tbb.iString   = -1;
	tbb.iBitmap   = num;
	tbb.idCommand = 10000 + num;
	SendMessage(g_hTool, TB_INSERTBUTTON, num, (LPARAM) &tbb);
}// Insert_Bttn

// I
void Clear_Select()
{
	ZeroMemory(g_sel, sizeof(g_sel));
	InvalidateRect(g_hChild, NULL, FALSE);
}// Clear_Select

// }bvf[^
void Clear_Map()
{
	int i,j;
	for(j=0;j<g_map_h;j++){
		for(i=0;i<g_map_w;i++){
			if(g_map[j][i] > 0){
				Set_Value(i, j, 0, false);
			}
		}
	}
	InvalidateRect(g_hChild, NULL, FALSE);
}// Clear_Map

// ݑIĂ`bvԍ擾
// ߂l : `bvԍi -1j
int Get_ChipIndex()
{
	int i,val = -1;
	for(i=0;i<PIC_NUM;i++){
		if(TBSTATE_CHECKED & SendMessage(g_hTool, TB_GETSTATE, 10000+i, 0)){
			if(i == PIC_NUM-1){
				val = 0;
			}
			else{
				val = i+1;
			}
			break;
		}
	}
	return val;
}// Get_ChipIndex

// Zʒu擾
POINT Get_CellPos(LPARAM lParam)
{
	POINT	pos;
	pos.x = LOWORD(lParam);
	pos.y = HIWORD(lParam);
	return Get_CellPos(pos);
}// Get_CellPos

// Zʒu擾
POINT Get_CellPos(POINT pos)
{
	POINT posDst;
	if(pos.x < 0)	pos.x = 0;
	if(pos.y < 0)	pos.y = 0;
	posDst.x = (pos.x - 3 + scr_x) / PIC_WDH;
	posDst.y = (pos.y - 3 + scr_y) / PIC_HGT;
	return posDst;
}// Get_CellPos

// |bvAbvj[̃Zʒu擾
POINT Get_CellPosContextMenu()
{
	POINT pos = g_ptContextMenu;
	ScreenToClient(g_hChild, &pos);
	return Get_CellPos(pos);
}// Get_CellPosContextMenu

// wWɌݑIĂ`bvԍݒ
bool Set_Value(int x, int y)
{
	return Set_Value(x, y,  Get_ChipIndex(), true);
}// Set_Value

// wWɒlݒ
bool Set_Value(int x, int y, int val, bool bReDraw)
{
	bool	bSetVal = false;
	if(x < g_map_w && y < g_map_h && g_map[y][x] != val){
		Set_UnDo1(x, y, g_map[y][x]);
		g_map[y][x] = val;
		if(bReDraw){
			ReDraw(x, y);
		}
		bSetVal = true;
	}
	return bSetVal;
}// Set_Value

// wʒu̍ĕ`
void ReDraw(int x, int y)
{
	RECT rc;
	rc.left		= x*PIC_WDH+3-scr_x;
	rc.top		= y*PIC_HGT+3-scr_y;
	rc.right	= rc.left+PIC_WDH+1;
	rc.bottom	= rc.top+PIC_HGT+1;
	InvalidateRect(g_hChild, &rc, FALSE);
}// ReDraw

// Z͑IĂ邩H
bool Is_SelExist()
{
	int i,j;
	bool	flag_set_val = false;
	for(j=0;j<g_map_h;j++){
		for(i=0;i<g_map_w;i++){
			if(g_sel[j][i] > 0){
				flag_set_val = true;
				goto End;
			}
		}
	}
End:return flag_set_val;
}// Is_SelExist

// Rs[f[^݂͑邩H
bool Is_CopyDataExist()
{
	int i,j;
	bool	flag_set_val = false;
	for(j=0;j<g_map_h;j++){
		for(i=0;i<g_map_w;i++){
			if(g_copy_sel[j][i] > 0){
				flag_set_val = true;
				goto End;
			}
		}
	}
End:return flag_set_val;
}// Is_CopyDataExist

// ẴZI
void Select_AllCell()
{
	int i,j;
	for(j=0;j<g_map_h;j++){
		for(i=0;i<g_map_w;i++){
			g_sel[j][i] = 1;
		}
	}
}// Select_AllCell

// ̈h
void Bucket2(int x, int y, BYTE val)
{
	if(val >= 0 && val < 256){
		int		size = g_map_w * g_map_h;
		LPBYTE	data = (LPBYTE) malloc(size);
		ZeroMemory(data, size);
		int		i,j;
		for(j=0;j<g_map_h;j++){
			for(i=0;i<g_map_w;i++){
				int	pos = j * g_map_w + i;
				data[pos] = (BYTE) g_map[j][i];
			}
		}
		Bucket(data, x, y, g_map_w, g_map_h, val);
		for(j=0;j<g_map_h;j++){
			for(i=0;i<g_map_w;i++){
				int	pos = j * g_map_w + i;
				Set_Value(i, j, data[pos], false);
			}
		}
		FREE(data);
	}
}// Bucket2

// [ɖ߂]̗Zbg
void Set_UnDo1(int x, int y, int n)
{
	if(g_Undo_ct == -1){
		g_flag_Undo_off = FALSE;
		g_flag_Redo_off = TRUE;
	}

	g_Undo_ct ++;

	if(g_Undo_ct >= UNDO_MAX){
		g_Undo_ct = 0;
		g_flag_Undo_Max = TRUE;
	}

	Set_UnDo2(x, y, n);
}// Set_UnDo1

// [ɖ߂]̗Zbg [UnDo(),ReDo()Ŏgp]
void Set_UnDo2(int x, int y, int n)
{
	g_Undo[g_Undo_ct].x = x;
	g_Undo[g_Undo_ct].y = y;
	g_Undo[g_Undo_ct].n = n;
}// Set_UnDo2

// [ɖ߂]
void UnDo()
{
	int    n,x,y;
	
	if(g_Undo_ct > -1){
		x = g_Undo[g_Undo_ct].x;
		y = g_Undo[g_Undo_ct].y;
		n = g_Undo[g_Undo_ct].n;
		
		Set_UnDo2(x, y, g_map[y][x]);
		
		g_map[y][x] = n;
		
		g_Undo_ct --;
		
		ReDraw(x, y);
		
		if(g_Undo_ct == -1 && g_flag_Undo_Max == FALSE){
			g_flag_Undo_off = TRUE;
		}
		if(g_flag_Redo_off == TRUE){
			g_flag_Redo_off = FALSE;
		}
	}
}// UnDo

// [蒼]
void ReDo()
{
	int	x,y,n;
	
	if(g_Undo[g_Undo_ct+1].x != -1){
		g_Undo_ct ++;
		
		x = g_Undo[g_Undo_ct].x;
		y = g_Undo[g_Undo_ct].y;
		n = g_Undo[g_Undo_ct].n;

		Set_UnDo2(x, y, g_map[y][x]);
		
		g_map[y][x] = n;
		
		ReDraw(x, y);
		
		if(g_flag_Undo_off == TRUE){
			g_flag_Undo_off = FALSE;
		}
		if(g_Undo[g_Undo_ct+1].x == -1){
			g_flag_Redo_off = TRUE;
		}
	}
}// ReDo

// I[v_CAO
void Load_Dialog(HWND hWnd)
{
	OPENFILENAME ofn;
	char fn[MAX_PATH];
	fn[0] = '\0';
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.Flags = OFN_HIDEREADONLY; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter = "}bvt@C (*.map)\0" "*.map\0"
					  "ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if (GetOpenFileName(&ofn)){
		strcpy(g_file_name, fn);
		if(ofn.nFilterIndex == 1){
			if(strrchr(g_file_name, '.') == NULL){
				strcat(g_file_name, ".map");
			}
		}
		Load();
	}
}// Load_Dialog

// t@Cf[^ǂݍ
bool Load()
{
	HANDLE hFile;
	DWORD	dwRead;
	
	Set_Title();
	hFile = CreateFile(g_file_name, GENERIC_READ, FILE_SHARE_READ,
						NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		return 0;
	}
	char name[6] = "MAPY2";
	char name2[6];
	ReadFile(hFile, name2, sizeof(name2), &dwRead, NULL);
	if(strcmp(name, name2)){
		CloseHandle(hFile);
		return 0;
	}
	ReadFile(hFile, &g_map_w, sizeof(g_map_w), &dwRead, NULL);
	ReadFile(hFile, &g_map_h, sizeof(g_map_h), &dwRead, NULL);
	Clear_Map();
	Clear_Select();
	for(int i=0;i<g_map_h;i++){
		ReadFile(hFile, g_map[i], sizeof(BYTE) * g_map_w, &dwRead, NULL);
	}
	CloseHandle(hFile);
	if(g_hChild){
		Set_Scroll_nMax(g_hChild,  g_map_w * PIC_WDH + 6,  g_map_h * PIC_HGT + 6);
		InvalidateRect(g_hChild, NULL, FALSE);
	}
	return 1;
}// Load

// Z[u_CAO
void Save_Dialog(HWND hWnd)
{
	OPENFILENAME ofn;
	char fn[MAX_PATH];
	fn[0] = '\0';
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter = "}bvt@C (*.map)\0" "*.map\0"
					  "ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if (GetSaveFileName(&ofn)){
		strcpy(g_file_name, fn);
		if(ofn.nFilterIndex == 1){
			if(strrchr(g_file_name, '.') == NULL){
				strcat(g_file_name, ".map");
			}
		}
		if (GetFileAttributes(g_file_name) == FILE_ATTRIBUTE_READONLY)
			if(MessageBox(hWnd, "ǂݎpłB\nt@C㏑܂H", MYWNDTITLE, MB_YESNO | MB_ICONWARNING) == IDYES)
				Save();
			else
				strcpy(g_file_name, "");
		else
			Save();
	}
}// Save_Dialog

// t@CɃf[^
bool Save()
{
	HANDLE hFile;
	DWORD	dwWrite;
	
	Set_Title();
	hFile = CreateFile(g_file_name, GENERIC_WRITE, FILE_SHARE_WRITE,
						NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		return 0;
	}
	char name[6] = "MAPY2";
	WriteFile(hFile, name, sizeof(name), &dwWrite, NULL);
	WriteFile(hFile, &g_map_w, sizeof(g_map_w), &dwWrite, NULL);
	WriteFile(hFile, &g_map_h, sizeof(g_map_h), &dwWrite, NULL);
	for(int i=0;i<g_map_h;i++){
		if(!WriteFile(hFile, g_map[i], sizeof(BYTE) * g_map_w, &dwWrite, NULL)){
			return 0;
		}
	}
	CloseHandle(hFile);
	return 1;
}// Save

// EBhE^Cg̕ύX
void Set_Title()
{
	char	*p,s[MAX_PATH];
	p = strrchr(g_file_name, '\\');
	sprintf(s, "%s  <%s>", MYWNDTITLE, p+1);
	SendMessage(g_hWnd, WM_SETTEXT, 0, (LPARAM)s);
}// Set_Title

// Tuj[ACȅԐݒiCEBhEj
void Set_SubMenuState(HMENU hMenuSub, int index)
{
	switch(index)
	{
	case 0:	// t@C
		break;
	case 1:	// ҏW
		{
			if(g_flag_Undo_off){
				EnableMenuItem(hMenuSub, IDM_UNDO, MF_GRAYED | MF_BYCOMMAND);
			}
			else{
				EnableMenuItem(hMenuSub, IDM_UNDO, MF_ENABLED | MF_BYCOMMAND);
			}
			if(g_flag_Redo_off){
				EnableMenuItem(hMenuSub, IDM_REDO, MF_GRAYED | MF_BYCOMMAND);
			}
			else{
				EnableMenuItem(hMenuSub, IDM_REDO, MF_ENABLED | MF_BYCOMMAND);
			}
			switch (g_flag_mode)
			{
			case 0:
				CheckMenuRadioItem(hMenuSub, IDM_MODE_SELECT, IDM_MODE_BUCKET, IDM_MODE_SELECT, MF_BYCOMMAND | MFS_CHECKED);
				EnableMenuItem(hMenuSub, IDM_CUT,    MF_ENABLED | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_COPY,   MF_ENABLED | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_PASTE,  MF_ENABLED | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_SELALL, MF_ENABLED | MF_BYCOMMAND);
				break;
			case 1:
				CheckMenuRadioItem(hMenuSub, IDM_MODE_SELECT, IDM_MODE_BUCKET, IDM_MODE_LINE, MF_BYCOMMAND | MFS_CHECKED);
				EnableMenuItem(hMenuSub, IDM_CUT,    MF_GRAYED  | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_COPY,   MF_GRAYED  | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_PASTE,  MF_GRAYED  | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_SELALL, MF_GRAYED  | MF_BYCOMMAND);
				break;
			case 2:
				CheckMenuRadioItem(hMenuSub, IDM_MODE_SELECT, IDM_MODE_BUCKET, IDM_MODE_BUCKET, MF_BYCOMMAND | MFS_CHECKED);
				EnableMenuItem(hMenuSub, IDM_CUT,    MF_GRAYED | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_COPY,   MF_GRAYED | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_PASTE,  MF_GRAYED | MF_BYCOMMAND);
				EnableMenuItem(hMenuSub, IDM_SELALL, MF_GRAYED | MF_BYCOMMAND);
				break;
			}
			if(!Is_CopyDataExist()){
				EnableMenuItem(hMenuSub, IDM_PASTE, MF_GRAYED | MF_BYCOMMAND);
			}
			break;
		case 2:
			if(g_bShowGrid)
				Menu_State_Change(hMenuSub, IDM_GRID, MFS_CHECKED);
			else
				Menu_State_Change(hMenuSub, IDM_GRID, MFS_UNCHECKED);
		break;
			break;
		}
		break;
	}
}// Set_SubMenuState

// |bvAbvj[ACȅԐݒ
void Set_PopUpMenuState(HMENU hMenu)
{
	if(g_flag_Undo_off){
		EnableMenuItem(hMenu, IDM_UNDO, MF_GRAYED | MF_BYCOMMAND);
	}
	else{
		EnableMenuItem(hMenu, IDM_UNDO, MF_ENABLED | MF_BYCOMMAND);
	}
	if(g_flag_Redo_off){
		EnableMenuItem(hMenu, IDM_REDO, MF_GRAYED | MF_BYCOMMAND);
	}
	else{
		EnableMenuItem(hMenu, IDM_REDO, MF_ENABLED | MF_BYCOMMAND);
	}
	if(!Is_CopyDataExist()){
		EnableMenuItem(hMenu, IDM_PASTE, MF_GRAYED | MF_BYCOMMAND);
	}
}// Set_PopUpMenuState

// j[ACȅԂύX
void Menu_State_Change(HMENU hMenu, UINT ID, UINT state)
{
	MENUITEMINFO	mi;
	
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	
	GetMenuItemInfo(hMenu,ID,0,&mi);
	
	mi.fState = state;
	
	SetMenuItemInfo(hMenu,ID,0,&mi);
}// Menu_State_Change
